diff -rupN seq24-rev48 adding win32/src/seqroll.cpp seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqroll.cpp
--- seq24-rev48 adding win32/src/seqroll.cpp	2009-05-20 20:30:47.578125000 -0500
+++ seq24-rev48 win32 midiclock mouseinteraction adding mutegroups+keybind/src/seqroll.cpp	2009-05-20 20:30:56.328125000 -0500
@@ -20,6 +20,14 @@
 #include "event.h"
 #include "seqroll.h"
 
+const long c_handlesize = 16;
+
+inline static long
+clamp( long val, long low, long hi )
+{
+     return val < low ? low : hi < val ? hi : val;
+}
+
 
 seqroll::seqroll(perform *a_perf,
                  sequence *a_seq, 
@@ -74,9 +82,11 @@ seqroll::seqroll(perform *a_perf,
     m_moving    = false;
 	m_moving_init = false;
     m_growing   = false;
-    m_adding    = false;
     m_painting  = false;
     m_paste     = false;
+    m_is_drag_pasting = false;
+    m_is_drag_pasting_start = false;
+    m_justselected_one = false;
 
     m_old_progress_x = 0;
 
@@ -126,21 +136,8 @@ seqroll::~seqroll( )
 	delete m_clipboard;
 }
 
-/* popup menu calls this */
-void 
-seqroll::set_adding( bool a_adding )
-{
-    if ( a_adding ){
-
-	get_window()->set_cursor(  Gdk::Cursor( Gdk::PENCIL ));
-	m_adding = true;
     
-    } else {
 
-	get_window()->set_cursor( Gdk::Cursor( Gdk::LEFT_PTR ));
-	m_adding = false;
-    }
-}
 
 
 void 
@@ -342,23 +339,44 @@ seqroll::update_background()
                              m_window_x, 
                              m_window_y );
     
+    gint8 dash = 1;
+    m_gc->set_dashes( 0, &dash, 1 );
     /* draw horz grey lines */
     m_gc->set_foreground(m_grey);
     m_gc->set_line_attributes( 1,
                                Gdk::LINE_ON_OFF_DASH,
                                Gdk::CAP_NOT_LAST,
                                Gdk::JOIN_MITER );
-    gint8 dash = 1;
-    m_gc->set_dashes( 0, &dash, 1 ); 
     
     for ( int i=0; i< (m_window_y / c_key_y) + 1; i++ )
     {
+        if (global_interactionmethod == e_fruity_interaction)
+        {
+            if (0 == (((c_num_keys - i) - m_scroll_offset_key + ( 12 - m_key )) % 12))
+            {
+                /* draw horz black lines at C */
+                m_gc->set_foreground(m_dk_grey);
+                m_gc->set_line_attributes( 1,
+                                           Gdk::LINE_SOLID,
+                                           Gdk::CAP_NOT_LAST,
+                                           Gdk::JOIN_MITER );
+            }
+            else if (11 == (((c_num_keys - i) - m_scroll_offset_key + ( 12 - m_key )) % 12))
+            {
+                /* draw horz grey lines for the other notes */
+                m_gc->set_foreground(m_grey);
+                m_gc->set_line_attributes( 1,
+                                           Gdk::LINE_ON_OFF_DASH,
+                                           Gdk::CAP_NOT_LAST,
+                                           Gdk::JOIN_MITER );
+            }
+        }
+        
         m_background->draw_line(m_gc,
                             0,
                             i * c_key_y,
                             m_window_x,
                             i * c_key_y );
-        
         if ( m_scale != c_scale_off ){
             
             if ( !c_scales_policy[m_scale][ ((c_num_keys - i)
@@ -941,336 +959,42 @@ seqroll::start_paste( )
 bool
 seqroll::on_button_press_event(GdkEventButton* a_ev)
 {
-    int numsel;
-	
-    long tick_s;
-    long tick_f;
-    int note_h;
-    int note_l;
-	
-    int norm_x, norm_y, snapped_x, snapped_y;
-	
-    grab_focus(  );
-
-    bool needs_update = false;
-	
-    snapped_x = norm_x = (int) (a_ev->x + m_scroll_offset_x );
-    snapped_y = norm_y = (int) (a_ev->y + m_scroll_offset_y );
-	
-    snap_x( &snapped_x );
-    snap_y( &snapped_y );
-	
-    /* y is always snapped */
-    m_current_y = m_drop_y = snapped_y;
-
-    /* reset box that holds dirty redraw spot */
-    m_old.x = 0;
-    m_old.y = 0;
-    m_old.width = 0;
-    m_old.height = 0;
-
-    if ( m_paste ){
-
-        convert_xy( snapped_x, snapped_y, &tick_s, &note_h );
-        m_paste = false;
-        m_seq->push_undo();
-        m_seq->paste_selected( tick_s, note_h );
-
-        needs_update = true;
-
-    } else { 
-
-        /*  left mouse button     */
-        if ( a_ev->button == 1 ||
-             a_ev->button == 2 )
-        { 
-
-            /* selection, normal x */
-            m_current_x = m_drop_x = norm_x;
-
-            /* turn x,y in to tick/note */
-            convert_xy( m_drop_x, m_drop_y, &tick_s, &note_h );
-
-            if ( m_adding )
-            {
-                /* start the paint job */
-                m_painting = true;
-
-                /* adding, snapped x */
-                m_current_x = m_drop_x = snapped_x;
-                convert_xy( m_drop_x, m_drop_y, &tick_s, &note_h );
-
-                // test if a note is already there
-                // fake select, if so, no add
-                if ( ! m_seq->select_note_events( tick_s, note_h, 
-                                                  tick_s, note_h,
-                                                  sequence::e_would_select ))
-                {
-                
-                    /* add note, length = little less than snap */
-                    m_seq->push_undo();
-                    m_seq->add_note( tick_s, m_note_length - 2, note_h, true );
-
-                    needs_update = true;
-                }
-
-            }
-            else /* selecting */
-            {
-
-               
-                if ( !m_seq->select_note_events( tick_s, note_h,
-                                                tick_s, note_h, 
-                                                sequence::e_is_selected ))
-                {
-                    if ( ! (a_ev->state & GDK_CONTROL_MASK) )
-                    {
-                        m_seq->unselect();	    
-                    }
- 
-
-                    /* on direct click select only one event */
-                    numsel = m_seq->select_note_events( tick_s,note_h,tick_s,note_h, 
-                                                        sequence::e_select_one );
-
-                    /* none selected, start selection box */
-                    if ( numsel == 0 )
-                    {
-                        if ( a_ev->button == 1 )
-                            m_selecting = true;
-                    }
-                    else
-                    {
-                        needs_update = true;
-                    }
-                }
- 
-                
-                if ( m_seq->select_note_events( tick_s, note_h,
-                                                tick_s, note_h, 
-                                                sequence::e_is_selected ))
-                {
-                    if ( a_ev->button == 1 )
-                    {
-                        m_moving_init = true;
-                        needs_update = true;
-
-
-                        /* get the box that selected elements are in */
-                        m_seq->get_selected_box( &tick_s, &note_h, 
-                                &tick_f, &note_l );
-
-
-                        convert_tn_box_to_rect( tick_s, tick_f, note_h, note_l,
-                                &m_selected.x,
-                                &m_selected.y,
-                                &m_selected.width,
-                                &m_selected.height );
-
-                        /* save offset that we get from the snap above */
-                        int adjusted_selected_x = m_selected.x;
-                        snap_x( &adjusted_selected_x );
-                        m_move_snap_offset_x = ( m_selected.x - adjusted_selected_x);
-
-                        /* align selection for drawing */
-                        snap_x( &m_selected.x );
-
-                        m_current_x = m_drop_x = snapped_x;
-                    }
-
-                    /* middle mouse button  */
-                    if ( a_ev->button == 2 ){	
-
-                        /* moving, normal x */
-                        //m_current_x = m_drop_x = norm_x;
-                        //convert_xy( m_drop_x, m_drop_y, &tick_s, &note_h );
-
-                        m_growing = true;
-
-                        /* get the box that selected elements are in */
-                        m_seq->get_selected_box( &tick_s, &note_h, 
-                                    &tick_f, &note_l );
-
-                        convert_tn_box_to_rect( tick_s, tick_f, note_h, note_l,
-                                &m_selected.x,
-                                &m_selected.y,
-                                &m_selected.width,
-                                &m_selected.height );	
-                        
-                    }
-                }
-           }
-       }
-
-        /*     right mouse button      */
-        if ( a_ev->button == 3 ){
-            set_adding( true );
-        }
-
-   }
-
-    /* if they clicked, something changed */
-    if ( needs_update ){
-    
-        ////printf( "needs update\n" );
-        m_seq->set_dirty();
-        //redraw_events();
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_press_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_press_event(a_ev, *this);
     }
-    return true;
-
+    return false;
 }
 
 
 bool
 seqroll::on_button_release_event(GdkEventButton* a_ev)
 {
-    long tick_s;
-    long tick_f;
-    int note_h;
-    int note_l;
-    int x,y,w,h;
-    int numsel;
-
-    bool needs_update = false;
-
-    m_current_x = (int) (a_ev->x + m_scroll_offset_x );
-    m_current_y = (int) (a_ev->y + m_scroll_offset_y );
-
-    snap_y ( &m_current_y );
-
-    if ( m_moving )
-        snap_x( &m_current_x );
-
-    int delta_x = m_current_x - m_drop_x;
-    int delta_y = m_current_y - m_drop_y;
-
-    long delta_tick;
-    int delta_note;
-
-    if ( a_ev->button == 1 ){
-
-        if ( m_selecting ){
-
-            xy_to_rect ( m_drop_x,
-                    m_drop_y,
-                    m_current_x,
-                    m_current_y,
-                    &x, &y,
-                    &w, &h );
-
-            convert_xy( x,     y, &tick_s, &note_h );
-            convert_xy( x+w, y+h, &tick_f, &note_l );
-
-            numsel = m_seq->select_note_events( tick_s, note_h, tick_f, note_l, sequence::e_select );
-
-            needs_update = true;
-        }
-
-        if (  m_moving  ){
-
-            /* adjust for snap */
-            delta_x -= m_move_snap_offset_x;
-
-            /* convert deltas into screen corridinates */
-            convert_xy( delta_x, delta_y, &delta_tick, &delta_note );
-
-            /* since delta_note was from delta_y, it will be filpped
-               ( delta_y[0] = note[127], etc.,so we have to adjust */
-            delta_note = delta_note - (c_num_keys-1);
-
-            m_seq->push_undo();
-            m_seq->move_selected_notes( delta_tick, delta_note );
-            needs_update = true;
-        }
-
-   }
-
-    if ( a_ev->button == 2 ){	
-
-        if ( m_growing ){
-
-            /* convert deltas into screen corridinates */
-            convert_xy( delta_x, delta_y, &delta_tick, &delta_note );
-            m_seq->push_undo();
-
-            if ( a_ev->state & GDK_SHIFT_MASK )
-            {
-                m_seq->stretch_selected( delta_tick );
-            }
-            else
-            {
-                m_seq->grow_selected( delta_tick );
-            }
-
-            needs_update = true;
-        }
-    }
-
-    if ( a_ev->button == 3 ){	
-        set_adding( false );
+    switch (global_interactionmethod)
+    {
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_button_release_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_button_release_event(a_ev, *this);
     }
+    return false;
 
-    /* turn off */
-    m_selecting = false;
-    m_moving = false;
-    m_growing = false;
-    m_paste = false;
-    m_moving_init = false;
-    m_painting = false;
-
-    m_seq->unpaint_all();
- 
-    /* if they clicked, something changed */
-    if (  needs_update ){
-
-        ////printf( "needs_update2\n" );
-        m_seq->set_dirty();
-        //redraw_events();
-    }
-    return true;
 }
  
 
 bool
 seqroll::on_motion_notify_event(GdkEventMotion* a_ev)
 {
-    m_current_x = (int) (a_ev->x  + m_scroll_offset_x );
-    m_current_y = (int) (a_ev->y  + m_scroll_offset_y );
-
-    int note;
-    long tick;
-
-    if ( m_moving_init ){
-        m_moving_init = false;
-        m_moving = true;
-    }
-		 
-    
-    snap_y( &m_current_y );
-    convert_xy( 0, m_current_y, &tick, &note );
-	
-    m_seqkeys_wid->set_hint_key( note );
-	
-    if ( m_selecting || m_moving || m_growing || m_paste ){
-        
-        if ( m_moving || m_paste ){
-            snap_x( &m_current_x );
-        }
-        
-        draw_selection_on_window();
-        return true;
-	
-    }
-
-    if ( m_painting )
+    switch (global_interactionmethod)
     {
-        snap_x( &m_current_x );
-        convert_xy( m_current_x, m_current_y, &tick, &note );
-
-        m_seq->add_note( tick, m_note_length - 2, note, true );
-        return true;
+        case e_fruity_interaction:
+             return m_fruity_interaction.on_motion_notify_event(a_ev, *this);
+        case e_seq24_interaction:
+             return m_seq24_interaction.on_motion_notify_event(a_ev, *this);
     }
-    
     return false;
 }
 
@@ -1338,18 +1062,20 @@ seqroll::on_key_press_event(GdkEventKey*
 {
     bool ret = false;
 
-	if ( a_p0->keyval ==  GDK_space ){
-		    if (is_pattern_playing) {
-			    m_perform->stop_jack();
-			    m_perform->stop();
-		    	    is_pattern_playing=false;
-		    } else {
-			    m_perform->position_jack( false );  
-			    m_perform->start( false );
-			    m_perform->start_jack( );
-		    	    is_pattern_playing=true;
- 		    }
-            }
+    // the start/end key may be the same key (i.e. SPACEBAR)
+    // allow toggling when the same key is mapped to both triggers (i.e. SPACEBAR)
+    bool dont_toggle = m_perform->m_key_start != m_perform->m_key_stop;
+    if ( a_p0->keyval ==  m_perform->m_key_start && (dont_toggle || !is_pattern_playing) ){
+	    m_perform->position_jack( false );
+	    m_perform->start( false );
+	    m_perform->start_jack( );
+        is_pattern_playing=true;
+    }
+    else if ( a_p0->keyval ==  m_perform->m_key_stop && (dont_toggle || is_pattern_playing) ){
+        m_perform->stop_jack();
+        m_perform->stop();
+        is_pattern_playing=false;
+    }
 
     if ( a_p0->type == GDK_KEY_PRESS ){
 
@@ -1393,6 +1119,13 @@ seqroll::on_key_press_event(GdkEventKey*
                 m_seq->pop_undo();
                 ret = true;
             }
+            
+            /* select all events */
+            if ( a_p0->keyval == GDK_a || a_p0->keyval == GDK_A ){
+
+                m_seq->select_all();
+                ret = true;
+            }
         }
     }
 
